%define ALD_Ver		2.0

# ACHTUNG !!!! WARNING !!!! CROSS not run !!!! WARNING !!!!

Name:         perl

License:      (GPL+ or Artistic) and (GPLv2+ or Artistic) and Copyright Only and MIT and Public Domain and UCD
Summary:      The Perl interpreter
Version:      5.32.1
Release:      0
Epoch:        4

Url: http://www.cpan.org/src/

Source: %{name}-%{version}.tar.xz

%global __provides_exclude perl\\((VMS|Win32|BSD::|DB\\)$)
%global __requires_exclude perl\\((VMS|BSD::|Win32|Tk|Mac::|Your::Module::Here)

Provides: perl = %{epoch}:%{version}

Provides: perl(bytes_heavy.pl)
Provides: perl(dumpvar.pl)
Provides: perl(perl5db.pl)
Provides: perl(unicore::Name)

%define DestDir		/Compiler/%{name}-%{version}

# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}
%define ArchName %{_arch}-%{_os}

%define privlib		%{_libdir}/perl5
%define archlib		%{_libdir}/perl5/%{ArchName}
%define sitelib		%{_libdir}/perl5/site_perl
%define sitearch	%{_libdir}/perl5/site_perl/%{ArchName}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
The Perl interpreter
#-------------------------------
%package encode-full
Summary:      Encode CN JP KR
Requires: perl = %{epoch}:%{version}
%description encode-full
This module implements Japanese, Korean, China-based Chinese, charset encodings.
#-------------------------------
%package Unicode-build
Summary:      Unicode build for Perl
Requires: perl = %{epoch}:%{version}
%description Unicode-build
Unicode build for Perl
#-------------------------------
%package pod-tools
Summary:      POD documents tools for Perl
Requires: perl = %{epoch}:%{version}
%description pod-tools
POD documents tools for Perl
#-------------------------------
%package pod-doc
Summary:      pod-doc for Perl
%description pod-doc
pod-doc for Perl
#-------------------------------
%package tar
Summary:      module for Perl manipulation of .tar files
Requires: perl = %{epoch}:%{version}
%description tar
module for Perl manipulation of .tar files
#-------------------------------
%package utils
Summary:      Utilities
Requires: perl = %{epoch}:%{version}
%description utils
Utilities
#-------------------------------
%package man1
Summary:      man1 for Perl
%description man1
man1 for Perl
#-------------------------------
%package man3
Summary:      man3 for Perl
%description man3
man3 for Perl
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Requires: perl = %{epoch}:%{version}
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package Module-CoreList
Summary:        Tool for listing modules shipped with perl
Requires:       perl-devel = %{epoch}:%{version}
%description Module-CoreList
Tool for listing modules shipped with perl

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# without gdbm
rm -rf 'cpan/Memoize/Memoize/NDBM_File.pm'
sed -i '\|cpan/Memoize/Memoize/NDBM_File.pm|d' MANIFEST

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -falign-functions=4 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"
CFLAGS="$OPTFLAGS -std=gnu99"
LDFLAGS="-Wl,--gc-sections"
CXXFLAGS="$OPTFLAGS"

export CFLAGS LDFLAGS CXXFLAGS

./configure.gnu \
	-Dcc=gcc \
	-Dmyhostname=localhost \
	-Dperladmin=root@localhost \
	-Dprefix=%{_prefix} \
	-Dvendorprefix="%{_prefix}" \
	-Dsiteprefix="%{_prefix}" \
	-Dsitelib="%{sitelib}" \
	-Dsitearch="%{sitearch}" \
	-Dprivlib="%{privlib}" \
	-Darchlib="%{archlib}" \
	-Dvendorlib="%{privlib}/vendor_perl" \
	-Dvendorarch="%{archlib}/vendor_perl" \
	-Dlibpth="/usr/local/%{_lib} /%{_lib} /usr/%{_lib}" \
	-Duseshrplib \
	-Dusethreads \
	-Duseperlio \
	-Doptimize=-Os \
	-Darchname=%{ArchName} \
	-Ubincompat5005 \
	-Uversiononly \
	-Dpager='/usr/bin/less -isr' \
	-Dd_gethostent_r_proto -Ud_endhostent_r_proto -Ud_sethostent_r_proto \
	-Ud_endprotoent_r_proto -Ud_setprotoent_r_proto \
	-Ud_endservent_r_proto -Ud_setservent_r_proto \
	&>FConfigure_log.txt

make -j2 &>FMake2_log.txt


# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export  PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if 1
rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>Finstall_log.txt

rm $RPM_BUILD_ROOT%{archlib}/.packlist

mkdir -p $RPM_BUILD_ROOT%{archlib}/vendor_perl/auto
mkdir -p $RPM_BUILD_ROOT%{privlib}/vendor_perl

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local
%endif
# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_prefix}/bin/perl
%{_prefix}/bin/perl%{version}

%{_mandir}/man1/perl.1.gz

%dir %{privlib}
%{privlib}/App
%{privlib}/Archive
%{privlib}/Attribute
%{privlib}/B
%{privlib}/CPAN
%{privlib}/Carp
%{privlib}/Class
%{privlib}/Compress
%{privlib}/Config
%{privlib}/DBM_Filter
%{privlib}/Devel
%{privlib}/Digest
%{privlib}/Exporter

%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/Command
%{privlib}/ExtUtils/Command.pm
%{privlib}/ExtUtils/Constant
%{privlib}/ExtUtils/Constant.pm
%{privlib}/ExtUtils/Install.pm
%{privlib}/ExtUtils/Installed.pm
%{privlib}/ExtUtils/Liblist/
%{privlib}/ExtUtils/Liblist.pm
%{privlib}/ExtUtils/MakeMaker/
%{privlib}/ExtUtils/MakeMaker.pm
%{privlib}/ExtUtils/MM*.pm
%{privlib}/ExtUtils/MY.pm
%{privlib}/ExtUtils/Mkbootstrap.pm
%{privlib}/ExtUtils/Mksymlists.pm
%{privlib}/ExtUtils/Packlist.pm
%{privlib}/ExtUtils/testlib.pm
%{privlib}/ExtUtils/typemap
%{privlib}/File
%{privlib}/Filter
%{privlib}/Getopt
%{privlib}/HTTP
%{privlib}/I18N
%{privlib}/IO
%{privlib}/IPC
%{privlib}/JSON

%dir %{privlib}/Locale
%dir %{privlib}/Locale/Maketext
%{privlib}/Locale/Maketext/*.pm
%{privlib}/Locale/*.pm
%{privlib}/Math
%{privlib}/Memoize
%dir %{privlib}/Module
%{privlib}/Module/Load.pm
%{privlib}/Module/Load/
%{privlib}/Module/Loaded.pm
%{privlib}/Module/Metadata.pm
%{privlib}/Net
%{privlib}/Params
%{privlib}/Parse
%{privlib}/Perl
%{privlib}/PerlIO
%{privlib}/Pod
%{privlib}/Search
%{privlib}/TAP
%{privlib}/Term
%{privlib}/Test
%{privlib}/Test2
%{privlib}/Text
%{privlib}/Thread
%{privlib}/Tie
%{privlib}/Time
%dir %{privlib}/Unicode
%{privlib}/Unicode/UCD.pm
%dir %{privlib}/Unicode/Collate
%{privlib}/Unicode/Collate/keys.txt
%{privlib}/Unicode/Collate/CJK
%{privlib}/Unicode/Collate/Locale
%{privlib}/User
%{privlib}/autodie
%{privlib}/encoding
%{privlib}/overload
%dir %{privlib}/version
%{privlib}/version/*.pm

%{privlib}/*.pl
%{privlib}/*.pm

%dir %{archlib}
%{archlib}/*.pm
%{archlib}/*.pl
%{archlib}/B
%dir %{archlib}/CORE
%{archlib}/CORE/*.so
%{archlib}/Compress
%{archlib}/Data
%{archlib}/Devel
%{archlib}/Digest

%dir %{archlib}/Encode
%{archlib}/Encode/MIME
%{archlib}/Encode/Unicode
%{archlib}/Encode/Alias.pm
%{archlib}/Encode/Byte.pm
%{archlib}/Encode/CJKConstants.pm
%{archlib}/Encode/Config.pm
%{archlib}/Encode/EBCDIC.pm
%{archlib}/Encode/Encoder.pm
%{archlib}/Encode/Encoding.pm
%{archlib}/Encode/GSM0338.pm
%{archlib}/Encode/Guess.pm
%{archlib}/Encode/Symbol.pm
%{archlib}/Encode/Unicode.pm

%{archlib}/File
%{archlib}/Filter
%{archlib}/I18N
%{archlib}/Hash
%{archlib}/IO
%{archlib}/IPC
%{archlib}/List
%{archlib}/MIME
%{archlib}/Math
%{archlib}/PerlIO
%{archlib}/Scalar
#{archlib}/Storable
%{archlib}/Sub
%{archlib}/Sys
#{archlib}/Tie
%{archlib}/Time
%{archlib}/Unicode

%dir %{archlib}/auto
%{archlib}/auto/B
%{archlib}/auto/Compress
%{archlib}/auto/Cwd
%{archlib}/auto/Data
%{archlib}/auto/Devel
%{archlib}/auto/Digest
%dir %{archlib}/auto/Encode
%{archlib}/auto/Encode/*.*
%{archlib}/auto/Encode/Byte
%{archlib}/auto/Encode/EBCDIC
%{archlib}/auto/Encode/Symbol
%{archlib}/auto/Encode/Unicode
%{archlib}/auto/Fcntl
%{archlib}/auto/File
%{archlib}/auto/Filter
%{archlib}/auto/Hash
%{archlib}/auto/I18N
%{archlib}/auto/IO
%{archlib}/auto/IPC
%{archlib}/auto/List
%{archlib}/auto/MIME
%{archlib}/auto/Math
%{archlib}/auto/Opcode
%{archlib}/auto/POSIX
%{archlib}/auto/PerlIO
%{archlib}/auto/SDBM_File
%{archlib}/auto/Socket
%{archlib}/auto/Storable

%{archlib}/auto/Sys
%{archlib}/auto/Time
%{archlib}/auto/Unicode
%{archlib}/auto/attributes
%{archlib}/auto/mro
%{archlib}/auto/re
%{archlib}/auto/threads

%{archlib}/threads

%exclude %{privlib}/unicore/*.txt
%{privlib}/unicore
%{privlib}/warnings

%dir %{sitelib}
%dir %{sitearch}

%dir %{privlib}/vendor_perl
%dir %{archlib}/vendor_perl
%dir %{archlib}/vendor_perl/auto


%files encode-full
%dir %{archlib}/Encode
%{archlib}/Encode/CN
%{archlib}/Encode/JP
%{archlib}/Encode/KR
%{archlib}/Encode/CN.pm
%{archlib}/Encode/JP.pm
%{archlib}/Encode/KR.pm
%{archlib}/Encode/TW.pm
%{archlib}/auto/Encode/CN
%{archlib}/auto/Encode/JP
%{archlib}/auto/Encode/KR
%{archlib}/auto/Encode/TW

%files Unicode-build
%dir %{privlib}/Unicode/Collate
%{privlib}/Unicode/Collate/allkeys.txt
%dir %{privlib}/unicore
%{privlib}/unicore/*.txt

%files pod-tools
%{_bindir}/perldoc
%{_bindir}/perlthanks
%{_bindir}/pod2html
%{_bindir}/pod2man
%{_bindir}/pod2text
%{_bindir}/pod2usage
%{_bindir}/podchecker
#{_bindir}/podselect

%files pod-doc
%{privlib}/*.pod
%{privlib}/pod
%dir %{privlib}/Encode
%{privlib}/Encode/*.pod
%{privlib}/ExtUtils/*.pod
%{privlib}/Locale/Maketext/*.pod
%{privlib}/Locale/*.pod
%dir %{privlib}/Module
%{privlib}/Module/*.pod
%{archlib}/*.pod
%{privlib}/version/*.pod

%files tar
%{_bindir}/ptar
%{_bindir}/ptardiff
%{_bindir}/ptargrep
%{_bindir}/zipdetails

%files utils
%{_bindir}/cpan
%{_bindir}/encguess
%{_bindir}/instmodsh
%{_bindir}/json_pp
%{_bindir}/piconv
%{_bindir}/pl2pm
%{_bindir}/shasum
%{_bindir}/splain
%{_bindir}/streamzip

%files man1
%exclude %{_mandir}/man1/perl.1.gz
%{_mandir}/man1

%files man3
%{_mandir}/man3

%files devel
%{_bindir}/enc2xs
%{_bindir}/h2ph
%{_bindir}/h2xs
%{_bindir}/libnetcfg
%{_bindir}/perlbug
%{_bindir}/perlivp
%{_bindir}/prove
%{_bindir}/xsubpp
%dir %{privlib}/Encode
%{privlib}/Encode/*.e2x
%{privlib}/Encode/*.h
%dir %{privlib}/ExtUtils
%{privlib}/ExtUtils/CBuilder
%{privlib}/ExtUtils/CBuilder.pm
%{privlib}/ExtUtils/Embed.pm
%{privlib}/ExtUtils/Manifest.pm
%{privlib}/ExtUtils/MANIFEST.SKIP
%{privlib}/ExtUtils/Miniperl.pm
%{privlib}/ExtUtils/ParseXS
%{privlib}/ExtUtils/ParseXS.pm
%{privlib}/ExtUtils/Typemaps
%{privlib}/ExtUtils/Typemaps.pm
%{privlib}/ExtUtils/xsubpp

%dir %{archlib}/CORE
%{archlib}/CORE/*.h

%files Module-CoreList
%{_bindir}/corelist
%dir %{privlib}/Module
%dir %{privlib}/Module/CoreList
%{privlib}/Module/CoreList/Utils.pm
%{privlib}/Module/CoreList.pm
